'use strict';

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

////////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////////
function readCookie(key) {
    var regex = new RegExp('(?:^|; )' + encodeURIComponent(key) + '=([^;]*)');
    var result = regex.exec(document.cookie);

    return result ? result[1] : null;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////////
function homegearRandomUserName() {
    var possible = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';
    var id = 'ui';

    for (var i = 0; i < 8; i++) {
        id += possible.charAt(Math.floor(Math.random() * possible.length));
    }return id;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////////
function homegear_new() {
    return new (Function.prototype.bind.apply(HomegearWS, [null].concat([websocket_url, websocket_port, homegearRandomUserName(), websocket_security_ssl], Array.prototype.slice.call(arguments))))();
}

var websocket_security_ssl = true; //Enabled by default
if (location.protocol == 'http:') websocket_security_ssl = false;

if (websocket_url == '' || !websocket_url) console.log('Homegear settings error!');

var homegear = homegear_new(readCookie('PHPSESSIDUI'));

////////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////////
homegear.ready(function () {
    var addDevicesAsHomegearPeers = Object.keys(interfaceData.map_invoke).map(Number);

    console.log('HomegearPeers: ');
    console.log(addDevicesAsHomegearPeers);

    homegear.addPeers(addDevicesAsHomegearPeers);
    $('#loadingPage').hide();
});

homegear.connected(function () {});

homegear.disconnected(function () {
    $('#loadingPage').show();
});

////////////////////////////////////////////////////////////////////////////////////////////////////////
//get new sessionid when websocket reconnects
////////////////////////////////////////////////////////////////////////////////////////////////////////
homegear.reconnected(function () {
    window.location.reload(true);
});

////////////////////////////////////////////////////////////////////////////////////////////////////////
//print Homegear errors
////////////////////////////////////////////////////////////////////////////////////////////////////////
homegear.error(function (message) {
    console.log(message);
});

////////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////////
homegear.event(function (x) {
    return console.log(JSON.stringify(x, null, 4));
});

homegear.event(handle_homegear_update);

if (location.protocol == 'https:' && websocket_security_ssl !== true) console.log('Homegear security issue!');else homegear.connect();

////////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////////
function handle_homegear_update(resp) {
    // DEBUG: works as expected
    var peer = resp.params[1],
        channel = resp.params[2],
        name = resp.params[3],
        value = resp.params[4];

    if (!(peer in interfaceData.map_invoke && channel in interfaceData.map_invoke[peer] && name in interfaceData.map_invoke[peer][channel])) return;

    var inputs = interfaceData.map_invoke[peer][channel][name];
    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
        for (var _iterator = inputs[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var input = _step.value;

            if (!(input.databaseId in interfaceData.devices && input.control in interfaceData.devices[input.databaseId].controls && input.input in interfaceData.devices[input.databaseId].controls[input.control].variableInputs)) continue;

            interfaceData.devices[input.databaseId].controls[input.control].variableInputs[input.input].properties.value = value;

            var _iteratorNormalCompletion2 = true;
            var _didIteratorError2 = false;
            var _iteratorError2 = undefined;

            try {
                for (var _iterator2 = input.roles[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
                    var role = _step2.value;

                    app.$root.$emit('role-update', role);
                }
            } catch (err) {
                _didIteratorError2 = true;
                _iteratorError2 = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion2 && _iterator2.return) {
                        _iterator2.return();
                    }
                } finally {
                    if (_didIteratorError2) {
                        throw _iteratorError2;
                    }
                }
            }
        }
    } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
    } finally {
        try {
            if (!_iteratorNormalCompletion && _iterator.return) {
                _iterator.return();
            }
        } finally {
            if (_didIteratorError) {
                throw _iteratorError;
            }
        }
    }
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
// Extensions to the homegear object
////////////////////////////////////////////////////////////////////////////////////////////////////////
function params_create(input, value) {
    if ('value' in input) {
        value = input.value;
    }
    return [Number(input.peer), Number(input.channel), input.name, value, false];
}

homegear.invoke_multi = function (ops) {
    var object = {
        jsonrpc: '2.0',
        method: 'system.multicall',
        params: ops
    };

    console.log(JSON.stringify(object, null, 4));

    return this.invoke(object);
};

homegear.value_set_multi = function (ops) {
    return this.invoke_multi([ops.map(function (op) {
        return {
            methodName: 'setValue',
            params: params_create(op.input, op.value)
        };
    })]);
};

homegear.value_set_clickcounter = function (control, params, value) {
    var methods = [[{
        methodName: 'setValue',
        params: params_create(params, value)
    }]];

    if (Date.now() - control.lastClickCount > 10000) {
        control.lastClickCount = Date.now();
        methods[0].push({
            methodName: 'setUserData',
            params: ['ui.clickCounts', control.uiElement.databaseId.toString(), ++control.uiElement.clickCount]
        });
    }

    return this.invoke_multi(methods);
};
////////////////////////////////////////////////////////////////////////////////////////////////////////
// globale Variablen sind zusätzlich in der settings.php definiert
////////////////////////////////////////////////////////////////////////////////////////////////////////
var controlComponents = {};

////////////////////////////////////////////////////////////////////////////////////////////////////////
// write console logs to setting/about/nameClick/log page
////////////////////////////////////////////////////////////////////////////////////////////////////////
if (typeof console_log !== 'undefined' && (console_log == 'true' || console_log == true)) {
    console.oldLog = console.log;
    console.log = function (value) {
        console.oldLog(value);

        if (value !== null && (typeof value === 'undefined' ? 'undefined' : _typeof(value)) === 'object') value = JSON.stringify(value);

        $('#log').append(value + '<br/>');
        $('#log').scrollTop(9999999999);
    };
} else {
    console.oldLog = console.log;
    console.log = function () {};
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
// isJSON
////////////////////////////////////////////////////////////////////////////////////////////////////////
function isJSON(str) {
    try {
        JSON.parse(str);
    } catch (e) {
        return false;
    }
    return true;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////////
$('#' + breadcrumbs_id_array[0]).addClass('content_single');
$('.breadcrumbsJump').html(firstBreadcrumb);

////////////////////////////////////////////////////////////////////////////////////////////////////////
// verhindert das die Zurück Funktion bei DesktopBrowsern ausgeführt werden kann
////////////////////////////////////////////////////////////////////////////////////////////////////////
location.hash = 'nb';
$(window).on('hashchange', function () {
    content('back', { back: '1' });
    location.hash = 'nb';
});

////////////////////////////////////////////////////////////////////////////////////////////////////////
// verhindert, dass der PullFromTopToRefresh im Android Chrome Browser ausgeführt werden kann
////////////////////////////////////////////////////////////////////////////////////////////////////////
var lastTouchY = 0;
var preventPullToRefresh = false;

$('body').on('touchstart', function (e) {
    if (e.originalEvent.touches.length != 1) return;

    lastTouchY = e.originalEvent.touches[0].clientY;
    preventPullToRefresh = window.pageYOffset == 0;
});

$('body').on('touchmove', function (e) {
    var touchY = e.originalEvent.touches[0].clientY;
    var touchYDelta = touchY - lastTouchY;

    lastTouchY = touchY;
    if (preventPullToRefresh) {
        preventPullToRefresh = false;
        if (touchYDelta > 0) {
            e.preventDefault();
            return;
        }
    }
});

////////////////////////////////////////////////////////////////////////////////////////////////////////
// passt die Header Tab Anzeige beim scrollen an
////////////////////////////////////////////////////////////////////////////////////////////////////////
headerVisibility('true');
function headerVisibility(state) {
    var stateDownScroll = state === 'true' ? 'block' : 'none';
    var stateUpScroll = 'block';
    var lastScrollTop = 0;

    $('.content').scroll(function (event) {
        var st = $(this).scrollTop();

        if (st > lastScrollTop) {
            // downscroll code
            $('.content_single #tabs').hide();
            $('.content_big #tabs').hide();
        } else {
            // upscroll code
            $('.content_single #tabs').show();
            $('.content_big #tabs').show();
        }
        lastScrollTop = st;
    });
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
// ermoeglicht die gesamte Navigationslogik
// Über ein Array wird zwischen den Ebenen gesprungen
////////////////////////////////////////////////////////////////////////////////////////////////////////
function content_delete_breadcumb_container(ids, vals) {
    $('#' + ids[ids.length - 1]).remove();
    vals.pop();
    ids.pop();
}

function content_hndl_breadcrumb_classes(ids, destSize) {
    if (ids.length > 1) {
        $('#' + ids[ids.length - 1]).addClass(destSize);
        $('#' + ids[ids.length - 2]).addClass('content_small');
    } else if (breadcrumbs_id_array.length == 1) {
        $('#' + ids[ids.length - 1]).addClass('content_single');
        $('#back').addClass('inactive');
    } else $('#back').addClass('inactive');
}

function content(element, options) {
    var destSize = 'content_big';

    if ((typeof options === 'undefined' ? 'undefined' : _typeof(options)) != 'object') options = $.parseJSON(options);

    if ('back' in options && breadcrumbs_id_array.length <= 1) {
        $('#back').addClass('inactive');
        $('.content').scrollTop(0);
        return;
    }

    if ('existing' in options) var id = options.existing;

    if ('size' in options && options.size === 'mega_big') destSize = 'content_mega_big';

    if ('content' in options) {
        var id = '';
        var possible = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz';

        for (var i = 0; i < 8; i++) {
            id += possible.charAt(Math.floor(Math.random() * possible.length));
        }if (options.vue) {
            $('#inhalt').append('<div id="' + id + '" class="content"></div>');
            var vueContent = app.$el.querySelector('#' + id);
            for (var _i in options.content) {
                vueContent.appendChild(options.content[_i]);
            }
        } else $('#inhalt').append('\n                <div id="' + id + '" class="content">\n                    ' + options['content'] + '\n                </div>\n            ');
    }

    $('.content_single').removeClass('content_single');
    $('.content_small').removeClass('content_small');
    $('.content_big').removeClass('content_big');
    $('.content_mega_big').removeClass('content_mega_big');
    $('.content_back').remove();

    if ('jump' in options) {
        for (var _i2 = breadcrumbs_id_array.length - options.jump; _i2 > 1; _i2--) {
            content_delete_breadcumb_container(breadcrumbs_id_array, breadcrumbs_array);
        }content_hndl_breadcrumb_classes(breadcrumbs_id_array, destSize);
    } else if ('back' in options) {
        //löschen des aktuellen containers
        content_delete_breadcumb_container(breadcrumbs_id_array, breadcrumbs_array);

        content_hndl_breadcrumb_classes(breadcrumbs_id_array, destSize);
    } else {
        breadcrumbs_array.push('\n            <div class="breadcrumbsJump"\n                 onclick=\'content(this, {"jump":"' + breadcrumbs_array.length + '"});\'>\n                ' + options.name + '\n            </div>\n        ');

        $('#' + id).addClass(destSize);
        $('#' + breadcrumbs_id_array[breadcrumbs_id_array.length - 1]).addClass('content_small');
        breadcrumbs_id_array.push(id);
        $('#back').removeClass('inactive');
    }

    $('.content_small').append('\n        <div class="content_back" onclick=\'content(this, {"back":"1"});\'>\n        </div>\n    ');

    var text = '';
    for (var _i3 = 0; _i3 < breadcrumbs_array.length; _i3++) {
        text += breadcrumbs_array[_i3];

        if (_i3 + 1 != breadcrumbs_array.length) text += '<div class="breadcrumbs_separator">|</div>';
    }

    document.getElementById('breadcrumbsSub').innerHTML = text;

    $('#breadcrumbsSub').scrollLeft(9999999999);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
// triggert beim Logoff eines Users das Löschen des Cookies
////////////////////////////////////////////////////////////////////////////////////////////////////////
function user_logoff() {
    window.location.href = 'signin.php?logout=1';
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
// Ladebildschirm
////////////////////////////////////////////////////////////////////////////////////////////////////////
$(document).ready(function () {});

////////////////////////////////////////////////////////////////////////////////////////////////////////
// Tabs
////////////////////////////////////////////////////////////////////////////////////////////////////////
function showTab(element, tab) {
    // Aktiven Tab finden und deaktivieren
    $(element).parent().find('.active').removeClass('active');
    $(element).parent().find('.tab_pfeil').remove();

    // Angeklickten Tab aktivieren
    $(element).addClass('active');
    $(element).append('<div class="tab_pfeil"><svg version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0" y="0" width="200" height="100" viewBox="0, 0, 200, 100"><g id="Ebene_1"><path d="M0,-0 L204,-0 L101.747,100.002" /></g></svg></div>');

    // Content im aktiven Tab finden und deaktivieren
    $(element).parents('.content').find('.activeTab').removeClass('activeTab');

    // Content im angeklicktem Tab aktivieren
    $(element).parents('.content').find('.tabWrapper:eq(' + tab + ')').addClass('activeTab');

    $(element).parents('.content').scrollTop(0);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
// License
////////////////////////////////////////////////////////////////////////////////////////////////////////
function license() {
    var table_rows = licenses.map(function (x) {
        return '\n        <tr>\n            <td>' + x.name + '</td>\n            <td>' + x.version + '</td>\n            <td>' + x.rights + '</td>\n            <td>' + x.licensename + '</td>\n            <td>' + x.licenseurl + '</td>\n        </tr>\n    ';
    }).join('\n');

    var data = '\n        <div class="table1">\n            <table>\n                <tr>\n                    <th onclick=\'main(this, {"name":"Log","content":"log"})\'>\n                        ' + i18n('settings.about.table.name') + '\n                    </th>\n                    <th>' + i18n('settings.about.table.version') + '</th>\n                    <th>' + i18n('settings.about.table.rights') + '</th>\n                    <th>' + i18n('settings.about.table.license') + '</th>\n                    <th>' + i18n('settings.about.table.license.url') + '</th>\n                </tr>\n                ' + table_rows + '\n            </table>\n        </div>\n    ';

    content('this', { 'content': data, 'name': 'Lizenz' });
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////////
function check_value_in_key(haystack, haystackkey, haystackneedle) {
    $.each(haystack, function (_, value) {
        if (value[haystackkey] === haystackneedle) {
            return true;
        }
    });

    return false;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////////
function i18n(key) {
    var _arr = [interfaceData.i18n, interfaceData.i18n.default];

    for (var _i4 = 0; _i4 < _arr.length; _i4++) {
        var i = _arr[_i4];
        if (key in i) return i[key];
    }return 'NoTrans.';
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////////
function condition_check(condition, value) {
    if (condition === null || condition === undefined) return true;

    switch (condition.operator) {
        case 'not':
            return value != condition.value;
        case 'e':
            return value == condition.value;
        case 'g':
            return value > condition.value;
        case 'l':
            return value < condition.value;
        case 'ge':
            return value >= condition.value;
        case 'le':
            return value <= condition.value;
        case 't':
            return true;
        case 'f': // fall through
        default:
            return false;
    }
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////////
function condition_get_matching(rendering, props) {
    for (var i = 0; i < rendering.length; ++i) {
        var cur = rendering[i];

        if (condition_check(cur.condition, props.value)) return cur.definitions;
    }

    // return empty default
    return {};
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////////
function get_or_default(obj, key, def) {
    return (typeof obj === 'undefined' ? 'undefined' : _typeof(obj)) == 'object' && key in obj ? obj[key] : def;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////////
function set_or_extend(arr, idx, vals) {
    if (idx >= arr.length) arr.push(vals);else {
        var keys = Object.keys(vals);
        for (var i = 0; i < keys.length; ++i) {
            arr[idx][keys[i]] = vals[keys[i]];
        }
    }
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
// VUE default components
////////////////////////////////////////////////////////////////////////////////////////////////////////
// Clone {{{
// src: https://stackoverflow.com/a/728694
function clone(obj) {
    var copy;

    // Handle the 3 simple types, and null or undefined
    if (null == obj || 'object' != (typeof obj === 'undefined' ? 'undefined' : _typeof(obj))) return obj;

    // Handle Date
    if (obj instanceof Date) {
        copy = new Date();
        copy.setTime(obj.getTime());
        return copy;
    }

    // Handle Array
    if (obj instanceof Array) {
        copy = [];
        for (var i = 0, len = obj.length; i < len; i++) {
            copy[i] = clone(obj[i]);
        }
        return copy;
    }

    // Handle Object
    if (obj instanceof Object) {
        copy = {};
        for (var attr in obj) {
            if (obj.hasOwnProperty(attr)) copy[attr] = clone(obj[attr]);
        }
        return copy;
    }

    throw new Error('Unable to copy obj! Its type isn\'t supported.');
}
// }}}


// Utils {{{
Vue.component('shif-title', {
    props: {
        classname: String
    },
    template: '\n        <div class="device_title" v-bind:class="classname">\n            <slot></slot>\n        </div>\n    '
});

Vue.component('shif-status', {
    props: ['classname', 'key_vals'],
    template: '\n        <div class="device_status" v-bind:class="classname">\n            <template v-if="key_vals">\n                <span v-for="i in key_vals"\n                    class="device_status_entry">\n                    <span v-if="i.key" class="name">{{ i.key }}:</span>\n                    <span class="value">{{ i.value }}</span>\n                </span>\n            </template>\n            <template v-else>\n                <div class="device_status_entry">\n                    <slot></slot>\n                </div>\n            </template>\n        </div>\n    '
});

Vue.component('shif-icon', {
    props: {
        src: {
            type: String,
            required: true
        },
        classname: String,
        active: String,
        rotate: Boolean
    },

    template: '\n        <div v-bind:class="classname">\n            <template v-if="src in interfaceIcons">\n                <div class="svg_icon"\n                     v-bind:class="[src, active, {accordion_arrow_rotated: rotate}]"\n                     v-html="interfaceIcons[src]">\n                </div>\n            </template>\n            <template v-else>\n                <div class="svg_icon icon_default"></div>\n            </template>\n        </div>\n    '
});

Vue.component('shif-slider', {
    props: {
        min: Number,
        max: Number,
        unit: String,
        value: Number,
        title: String
    },

    template: '\n        <div class="device_wrapper">\n            <div class="device slider">\n                <shif-title>{{ title }}</shif-title>\n\n                <div class="slider_action">\n                    <div class="amount">\n                        <p>{{ value }} {{ unit }}</p>\n                    </div>\n                </div>\n\n                <input type="range"\n                        class="range"\n                        name="range"\n                        step="1"\n                        v-bind:min="min"\n                        v-bind:max="max"\n                        v-bind:value="value"\n                        v-on:change="$emit(\'change\', parseInt($event.target.value))"\n                        v-on:input="$emit(\'input\', parseInt($event.target.value))" />\n\n                <div class="slider_marks">\n                    <div class="left">\n                        {{ min }} {{ unit }}\n                    </div>\n                    <div class="right">\n                        {{ max }} {{ unit }}\n                    </div>\n                </div>\n            </div>\n        </div>\n    '
});

Vue.component('shif-radio', {
    props: ['title', 'classname', 'values'],

    computed: {
        identifier: function identifier() {
            return 'x' + Math.random().toString(36).substring(10);
        }
    },

    template: '\n        <div class="device_wrapper">\n            <div class="device">\n                <shif-title>{{ title }}</shif-title>\n                <div class="device_radio">\n                    <template v-for="i in values">\n                        <label class="rad">\n                            <span class="rad_name">{{ i.name }}</span>\n                            <input type="radio"\n                                   v-bind:name="identifier"\n                                   v-bind:value="i.value"\n                                   v-bind:checked="i.selected"\n                                   v-on:input="$emit(\'input\', $event.target.value)" />\n                            <i></i>\n                        </label>\n                    </template>\n                </div>\n            </div>\n        </div>\n    '
});

Vue.component('shif-button', {
    props: {
        width: {
            type: String,
            default: '100%'
        },
        classname: String
    },
    template: '\n        <div class="control_button"\n             v-bind:class="classname"\n             v-bind:style="{width}"\n             v-on:click="$emit(\'click\', 1)">\n            <slot></slot>\n        </div>\n    '
});
// }}}


// Generic l2 {{{
Vue.component('shif-generic-l2', {
    props: {
        icon: String,
        place: String,
        title: String,
        status: [Array, String],
        actions: Boolean,
        icon_rotate: Boolean,
        accordion: Boolean,
        active: {
            type: Object,

            default: function _default() {
                return {
                    icon: '',
                    text: ''
                };
            }
        }
    },

    mounted: function mounted() {
        if (this.$listeners && this.$listeners.click !== undefined && this.$listeners.click_icon === undefined) this.$on('click_icon', this.$listeners.click);
    },

    template: '\n        <div class="device_wrapper"\n             v-on:mousedown="$emit(\'mousedown\')"\n             v-on:mouseup="$emit(\'mouseup\')"\n             v-on:click="$emit(\'click\')">\n            <div class="device">\n                <div v-on:click.stop="$emit(\'click_icon\')">\n                    <shif-icon v-bind:src="icon"\n                               v-bind:active="active.icon"\n                               classname="device_icon">\n                    </shif-icon>\n                </div>\n                <div class="device_text">\n                    <shif-title>{{ title }}</shif-title>\n                    <div v-if="place" class="device_location">\n                        {{ place }}\n                    </div>\n                    <template v-if="typeof(status) === \'object\'">\n                        <shif-status v-bind:classname="active.text"\n                                     v-bind:key_vals="status">\n                        </shif-status>\n                    </template>\n                    <template v-else>\n                        <shif-status v-bind:classname="active.text">{{ status }}</shif-status>\n                    </template>\n                </div>\n                <div v-if="actions"\n                     class="device_action">\n                    <template v-if="accordion">\n                        <shif-icon src="pfeil4" v-bind:rotate="icon_rotate"></shif-icon>\n                    </template>\n                    <template v-else>\n                        <shif-icon src="pfeil3"></shif-icon>\n                    </template>\n                </div>\n            </div>\n        </div>\n    '
});
// }}}


// [shif_device] Generic Shif Device Component Object {{{
function status_impl(control) {
    var out = [];

    var key = control.texts && control.texts.l2_state_title && control.texts.l2_state_title.content ? control.texts.l2_state_title.content : null;
    var val = [];

    var _iteratorNormalCompletion3 = true;
    var _didIteratorError3 = false;
    var _iteratorError3 = undefined;

    try {
        for (var _iterator3 = control.variableInputs[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
            var input = _step3.value;

            if (!input.properties.visualizeInOverview) continue;

            if (input.rendering) {
                var sel = condition_get_matching(input.rendering, input.properties);
                if (Object.keys(sel).length > 0) {
                    val.push(sel.texts.state.content);
                    continue;
                }
            }

            var unit = input.properties.unit ? input.properties.unit : '';
            val.push(input.properties.value + unit);
        }
    } catch (err) {
        _didIteratorError3 = true;
        _iteratorError3 = err;
    } finally {
        try {
            if (!_iteratorNormalCompletion3 && _iterator3.return) {
                _iterator3.return();
            }
        } finally {
            if (_didIteratorError3) {
                throw _iteratorError3;
            }
        }
    }

    if (val.length > 0) out.push({ key: key, value: val.join(', ') });

    return out;
}

var shif_device = {
    props: ['uiElement', 'control', 'device', 'icons', 'texts', 'output', 'props', 'index', 'rendering', 'include_place'],

    data: function data() {
        return {
            lastClickCount: 0
        };
    },

    methods: {},

    computed: {
        cond: function cond() {
            var sel = condition_get_matching(this.rendering, this.props);

            return {
                text: get_or_default(sel.texts, 'state', { content: '', color: '' }),
                icon: get_or_default(sel.icons, 'state', { name: '', color: '' })
            };
        },

        dev: function dev() {
            return interfaceData.devices[this.device];
        },

        place: function place() {
            if (!this.include_place) return null;

            var room = interfaceData.rooms[this.dev.room];
            if (userSettings.showFloor !== 'true') return room.name;

            return room.floors.map(function (x) {
                return interfaceData.floors[x];
            }).map(function (x) {
                return x.name + ' - ' + room.name;
            }).join(' | ');
        },

        title: function title() {
            if (this.control.texts && this.control.texts.title && this.control.texts.title.content) return this.control.texts.title.content;

            return this.dev.label;
        },

        status: function status() {
            var out = [];

            var _iteratorNormalCompletion4 = true;
            var _didIteratorError4 = false;
            var _iteratorError4 = undefined;

            try {
                for (var _iterator4 = this.dev.controls[Symbol.iterator](), _step4; !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
                    var control = _step4.value;

                    out = out.concat(status_impl(control));
                }
            } catch (err) {
                _didIteratorError4 = true;
                _iteratorError4 = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion4 && _iterator4.return) {
                        _iterator4.return();
                    }
                } finally {
                    if (_didIteratorError4) {
                        throw _iteratorError4;
                    }
                }
            }

            return out;
        },

        status_minimal: function status_minimal() {
            return status_impl(this.control);
        },

        breadcrumb: function breadcrumb() {
            return (this.place ? this.place + ' | ' : '') + this.dev.label;
        }
    }
};

function shif_comps_create(name, l2, l2_only_and_l3) {
    var shif_name = 'shif-' + name + '-';

    controlComponents[name] = {
        l2: Vue.component(shif_name + 'l2', l2),
        l2_only: Vue.component(shif_name + 'l2_only', l2_only_and_l3),
        l3: Vue.component(shif_name + 'l3', l2_only_and_l3)
    };
}
// }}}


////////////////////////////////////////////////////////////////////////////////////////////////////////
// liefert den view für das Editieren der Benutzereinstellungen
////////////////////////////////////////////////////////////////////////////////////////////////////////
function user(element, options) {
    var themesNames = [];
    var _iteratorNormalCompletion5 = true;
    var _didIteratorError5 = false;
    var _iteratorError5 = undefined;

    try {
        for (var _iterator5 = interfaceData.themes[Symbol.iterator](), _step5; !(_iteratorNormalCompletion5 = (_step5 = _iterator5.next()).done); _iteratorNormalCompletion5 = true) {
            var i = _step5.value;

            if (i.name === 'standard' || i.name === 'highlight') continue;

            var selected = userSettings.theme == i.name ? 'selected' : '';
            themesNames.push('\n            <option value="' + i.name + '" autocomplete="off" ' + selected + '>\n                ' + interfaceData.i18n['settings.user.manage.theme.' + i.name] + '\n            </option>\n        ');
        }
    } catch (err) {
        _didIteratorError5 = true;
        _iteratorError5 = err;
    } finally {
        try {
            if (!_iteratorNormalCompletion5 && _iterator5.return) {
                _iterator5.return();
            }
        } finally {
            if (_didIteratorError5) {
                throw _iteratorError5;
            }
        }
    }

    var langNames = [];
    $.each(interfaceData.i18n.languages, function (key, value) {
        var selected = userSettings.language == key ? 'selected' : '';
        langNames.push('\n            <option value="' + key + '" autocomplete="off" ' + selected + '>\n                ' + value.name + '\n            </option>\n        ');
    });

    var output = '\n        <div id="user_wrapper">\n        <form id="user_' + options.content + '" name="user_' + options.content + '" action="javascript:void(0);" onsubmit="user_' + options.content + '_commit();">\n            <div id="twofaContainer" class="form-group" style="display: none">\n                <div class="label">' + i18n('settings.user.manage.twofa') + ':</div>\n                <input id="registerWebauthn" onclick="user_register_webauthn_device()" type="button" class="" ' + (userHasTwofaRegistrations ? 'disabled="disabled"' : '') + ' value="' + (userHasTwofaRegistrations ? i18n('settings.user.manage.twofaRegistered') : i18n('settings.user.manage.registerTwofa')) + '">\n            </div>\n            <div class="form-group">\n                <div class="label">' + i18n('settings.user.manage.language') + ':</div>\n                <select id="language" name="language">\n                    ' + langNames + '\n                </select>\n            </div>\n            <div class="form-group">\n                <div class="label">' + i18n('settings.user.manage.theme') + ':</div>\n                <select id="theme" name="theme">\n                    ' + themesNames + '\n                </select>\n            </div>\n            <div id="user_highlight_display" class="form-group">\n                <div class="label">' + i18n('settings.user.manage.highlight') + ':</div>\n                <input id="highlight" type="hidden" name="highlight" value="' + userSettings.highlight + '">\n                    <div id="color-picker-container"></div>\n                <div style="clear:both;"></div>\n            </div>\n            <div class="form-group">\n                <input type="submit" class="" name="user_' + options.content + '" value="' + i18n('settings.user.manage.save') + '">\n            </div>\n        </form>\n        </div>\n    ';

    content('this', { 'content': output, 'name': options['name'] });
    if (twofaEnabled) $('#twofaContainer').show();

    var outerWidth = $('#user_edit').outerWidth();
    var userColorPickerWidth = outerWidth <= 400 ? outerWidth : 400;
    var userColorPickerHeight = userColorPickerWidth + 20;

    var userColorPicker = new iro.ColorPicker('#color-picker-container', {
        width: userColorPickerWidth,
        height: userColorPickerHeight,
        color: userSettings.highlight,
        markerRadius: 12,
        padding: 1,
        sliderMargin: 24,
        sliderHeight: 36,
        borderWidth: 3,
        borderColor: '#fff',
        anticlockwise: true
    });

    userColorPicker.on('color:change', function (color, changes) {
        $('#user_highlight_display #highlight').val(color.hexString);
    });
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
// Register a new WebAuthn device
////////////////////////////////////////////////////////////////////////////////////////////////////////
function user_register_webauthn_device() {
    /**
     * convert RFC 1342-like base64 strings to array buffer
     * @param {mixed} obj
     * @returns {undefined}
     */
    function recursiveBase64StrToArrayBuffer(obj) {
        var prefix = '?BINARY?B?';
        var suffix = '?=';
        if ((typeof obj === 'undefined' ? 'undefined' : _typeof(obj)) === 'object') {
            for (var key in obj) {
                if (typeof obj[key] === 'string') {
                    var str = obj[key];
                    if (str.substring(0, prefix.length) === prefix && str.substring(str.length - suffix.length) === suffix) {
                        str = str.substring(prefix.length, str.length - suffix.length);

                        var binary_string = window.atob(str);
                        var len = binary_string.length;
                        var bytes = new Uint8Array(len);
                        for (var i = 0; i < len; i++) {
                            bytes[i] = binary_string.charCodeAt(i);
                        }
                        obj[key] = bytes.buffer;
                    }
                } else {
                    recursiveBase64StrToArrayBuffer(obj[key]);
                }
            }
        }
    }

    /**
     * Convert a ArrayBuffer to Base64
     * @param {ArrayBuffer} buffer
     * @returns {String}
     */
    function arrayBufferToBase64(buffer) {
        var binary = '';
        var bytes = new Uint8Array(buffer);
        var len = bytes.byteLength;
        for (var i = 0; i < len; i++) {
            binary += String.fromCharCode(bytes[i]);
        }
        return window.btoa(binary);
    }

    if (userHasTwofaRegistrations) return;
    if (!window.fetch || !navigator.credentials || !navigator.credentials.create) {
        $('#registerWebauthn').val(i18n('settings.user.manage.browserNotSupported'));
        $('#registerWebauthn').attr('disabled', 'disabled');
        return;
    }

    window.fetch('webauthnServer.php?command=getCredentialArgs', { method: 'GET', cache: 'no-cache' }).then(function (response) {
        return response.json();
    }).then(function (json) {
        recursiveBase64StrToArrayBuffer(json);
        return json;
    }).then(function (createCredentialArgs) {
        return navigator.credentials.create(createCredentialArgs);
    }).then(function (cred) {
        return {
            clientDataJson: cred.response.clientDataJSON ? arrayBufferToBase64(cred.response.clientDataJSON) : null,
            attestationObject: cred.response.attestationObject ? arrayBufferToBase64(cred.response.attestationObject) : null
        };
    }).then(JSON.stringify).then(function (AuthenticatorAttestationResponse) {
        return window.fetch('webauthnServer.php?command=registerDevice', { method: 'POST', body: AuthenticatorAttestationResponse, cache: 'no-cache' });
    }).then(function (response) {
        return response.json();
    }).then(function (json) {
        if (json.success) {
            $('#registerWebauthn').val(i18n('settings.user.manage.twofaRegistered'));
            $('#registerWebauthn').attr('disabled', 'disabled');
        } else {
            throw new Error(json.msg);
        }
    }).catch(function (error) {
        $('#registerWebauthn').val(error.message);
        $('#registerWebauthn').attr('disabled', 'disabled');
    });
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
// verarbeitet das Editieren der Benutzereinstellungen
////////////////////////////////////////////////////////////////////////////////////////////////////////
function user_edit_commit() {
    userSettings.theme = $('#user_edit #theme').val() || 'dark';
    userSettings.highlight = $('#user_edit #highlight').val() || '#e3a104';
    userSettings.language = $('#user_edit #language').val() || 'en-US';

    var rpc_obj_get = {
        jsonrpc: '2.0',
        method: 'getUserMetadata',
        params: []
    };

    homegear.invoke(rpc_obj_get, updateUserSettingsData);

    function updateUserSettingsData(data) {
        var newUserSettings = data.result;
        if (!newUserSettings.interface) {
            newUserSettings.interface = userSettings;
        }

        newUserSettings.locale = userSettings.language;
        newUserSettings.interface.language = userSettings.language;
        newUserSettings.interface.theme = userSettings.theme;
        newUserSettings.interface.highlight = userSettings.highlight;

        var rpc_obj = {
            jsonrpc: '2.0',
            method: 'setUserMetadata',
            params: [newUserSettings]
        };

        homegear.invoke(rpc_obj, function () {
            window.location.href = interfacePath;
        });
    }
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////////
var shading_ventilation_l2 = clone(shif_device);
shading_ventilation_l2.methods.change = function (event) {
    homegear.value_set_clickcounter(this, this.output, !this.props.value);
};
shading_ventilation_l2.template = '\n    <shif-generic-l2 v-bind:icon="cond.icon.name"\n                     v-bind:title="dev.label"\n                     v-bind:active="{icon: cond.icon.color, text: cond.text.color}"\n                     v-bind:status="status"\n                     v-bind:place="place"\n                     v-bind:actions="true"\n                     v-on:click_icon="change"\n                     v-on:click="level3(device, breadcrumb)">\n    </shif-generic-l2>\n';

var shading_ventilation_l3 = clone(shif_device);
shading_ventilation_l3.methods.change = function (event) {
    homegear.value_set_clickcounter(this, this.output, !this.props.value);
};
shading_ventilation_l3.template = '\n    <shif-generic-l2 v-bind:icon="cond.icon.name"\n                     v-bind:title="title"\n                     v-bind:active="{icon: cond.icon.color, text: cond.text.color}"\n                     v-bind:place="place"\n                     v-bind:status="status_minimal"\n                     v-on:click="change">\n    </shif-generic-l2>\n';

shif_comps_create('shadingVentilation', shading_ventilation_l2, shading_ventilation_l3);
shif_comps_create('shadingWindalarm', shading_ventilation_l2, shading_ventilation_l3);

var shading_slider = clone(shif_device);
shading_slider.methods.change = function (event) {
    homegear.value_set_clickcounter(this, this.output, this.props.value);
};
shading_slider.template = '\n    <shif-slider v-bind:min="props.minimumScaled"\n                 v-bind:max="props.maximumScaled"\n                 v-bind:unit="props.unit"\n                 v-bind:value="props.value"\n                 v-bind:title="title"\n                 v-on:change="change"\n                 v-model:value="props.value">\n    </shif-slider>\n';

shif_comps_create('shadingPosition', shading_ventilation_l2, shading_slider);
shif_comps_create('shadingPositionSlats', shading_ventilation_l2, shading_slider);

var shading_buttons_l2 = clone(shif_device);
shading_buttons_l2.template = '\n    <shif-generic-l2 v-bind:icon="icons.l2.name"\n                     v-bind:title="dev.label"\n                     v-bind:active="{icon: icons.l2.color, text: texts.title.color}"\n                     v-bind:place="place"\n                     v-bind:actions="true"\n                     v-bind:status="status"\n                     v-on:click="level3(device, breadcrumb)">\n    </shif-generic-l2>\n';
var shading_buttons_l3 = clone(shif_device);
shading_buttons_l3.methods.change = function (event) {
    var upVar = this.control.variableOutputs[0];
    var downVar = this.control.variableOutputs[2];
    if ((this.index == 0 || this.index == 2) && !upVar.hasOwnProperty('value') && !downVar.hasOwnProperty('value') && upVar.peer == downVar.peer && upVar.channel == downVar.channel && upVar.name == downVar.name) {
        var down = this.index == 2;
        if ((this.output.type == 'integer' || this.output.type == 'integer64' || this.output.type == 'float') && this.output.hasOwnProperty('minimumValue') && this.output.hasOwnProperty('maximumValue')) {
            var output = clone(this.output);
            output.value = down ? this.output.maximumValue : this.output.minimumValue;
            homegear.value_set_clickcounter(this, output, null);
        } else if (this.output.type == 'bool') {
            var _output = clone(this.output);
            _output.value = down;
            homegear.value_set_clickcounter(this, _output, null);
        }
    } else homegear.value_set_clickcounter(this, this.output, true);
};
shading_buttons_l3.template = '\n    <div>\n        <div class="shading-buttons-up-down_control_button_wrapper">\n            <shif-button v-on:click="change">\n                <shif-icon v-bind:src="cond.icon.name"\n                           v-bind:active="cond.icon.color">\n                </shif-icon>\n            </shif-button>\n        </div>\n    </div>\n';

shif_comps_create('shadingButtons', shading_buttons_l2, shading_buttons_l3, shading_buttons_l3);
shif_comps_create('shadingButtonsSingleStep', shading_buttons_l2, shading_buttons_l3, shading_buttons_l3);
shif_comps_create('shadingButtonsUpDown', shading_buttons_l2, shading_buttons_l3, shading_buttons_l3);

////////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////////
var window_status = clone(shif_device);
window_status.template = '\n    <shif-generic-l2 v-bind:icon="cond.icon.name"\n                     v-bind:title="dev.label"\n                     v-bind:active="{icon: cond.icon.color, text: cond.text.color}"\n                     v-bind:status="status"\n                     v-bind:place="place">\n    </shif-generic-l2>\n';

shif_comps_create('windowContact', window_status, window_status);
shif_comps_create('windowHandle', window_status, window_status);

var window_buttons_l2 = clone(shif_device);
window_buttons_l2.template = '\n    <shif-generic-l2 v-bind:icon="icons.l2.name"\n                     v-bind:title="dev.label"\n                     v-bind:active="{icon: icons.l2.color, text: texts.title.color}"\n                     v-bind:place="place"\n                     v-bind:actions="true"\n                     v-bind:status="status"\n                     v-on:click="level3(device, breadcrumb)">\n    </shif-generic-l2>\n';
var window_buttons_l3 = clone(shif_device);
window_buttons_l3.methods.change = function (event) {
    var upVar = this.control.variableOutputs[0];
    var downVar = this.control.variableOutputs[2];
    if ((this.index == 0 || this.index == 2) && !upVar.hasOwnProperty('value') && !downVar.hasOwnProperty('value') && upVar.peer == downVar.peer && upVar.channel == downVar.channel && upVar.name == downVar.name) {
        var down = this.index == 2;
        if ((this.output.type == 'integer' || this.output.type == 'integer64' || this.output.type == 'float') && this.output.hasOwnProperty('minimumValue') && this.output.hasOwnProperty('maximumValue')) {
            var output = clone(this.output);
            output.value = down ? this.output.maximumValue : this.output.minimumValue;
            homegear.value_set_clickcounter(this, output, null);
        } else if (this.output.type == 'bool') {
            var _output2 = clone(this.output);
            _output2.value = down;
            homegear.value_set_clickcounter(this, _output2, null);
        }
    } else homegear.value_set_clickcounter(this, this.output, true);
};
window_buttons_l3.template = '\n    <div>\n        <div class="window-buttons-up-down_control_button_wrapper">\n            <shif-button v-on:click="change">\n                <shif-icon v-bind:src="cond.icon.name"\n                           v-bind:active="cond.icon.color">\n                </shif-icon>\n            </shif-button>\n        </div>\n    </div>\n';

shif_comps_create('windowButtonsUpDown', window_buttons_l2, window_buttons_l3, window_buttons_l3);

////////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////////
var door_status = clone(shif_device);
door_status.template = '\n    <shif-generic-l2 v-bind:icon="cond.icon.name"\n                     v-bind:title="dev.label"\n                     v-bind:active="{icon: cond.icon.color, text: cond.text.color}"\n                     v-bind:status="status"\n                     v-bind:place="place">\n    </shif-generic-l2>\n';

shif_comps_create('doorContact', door_status, door_status);
shif_comps_create('doorHandle', door_status, door_status);
shif_comps_create('doorSecurity', door_status, door_status);

////////////////////////////////////////////////////////////////////////////////////////////////////////
// Auflisten der Räume
////////////////////////////////////////////////////////////////////////////////////////////////////////
var house_level1_content = '';

function house_level1() {
    $.each(interfaceData.floors, function (floorKey, floorValue) {
        // Stockwerktitel anzeigen, wenn mehr als ein Stockwerk vorhanden ist
        if (Object.keys(interfaceData.floors).length > 1) house_level1_content += '\n                <div class="roomSelectTitle">\n                    ' + floorValue.name + '\n                </div>\n            ';

        house_level1_content += '<div class="rooms_wrapper"><center>';

        $.each(floorValue.rooms, function (_, roomValue) {
            var floorBreadcrumbName = showFloor === 'true' ? floorValue.name + ' - ' : '';

            var action = 'onclick=\'house_level2( this, {"name":"' + floorBreadcrumbName + interfaceData.rooms[roomValue]['name'] + '", "floor":"' + floorKey + '", "room":"' + roomValue + '"});\'';

            house_level1_content += '\n                <div class="roomSelect_wrapper" ' + action + '>\n                    <div class="roomSelect">\n                        ' + icons[interfaceData.rooms[roomValue].icon] + '\n                    </div>\n                    <div class="description">\n                        ' + interfaceData.rooms[roomValue].name + '\n                    </div>\n                </div>\n            ';
        });

        house_level1_content += '</center></div>';
    });
}

// TODO: Return value?
house_level1();

////////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////////
function component_create(constructor, data) {
    var comp = new constructor({
        propsData: data
    });

    comp.$mount();

    return comp.$el;
}

function component_object(control, device, input, output, index, is) {
    var ret = {
        uiElement: device,
        control: control,
        device: device.databaseId,
        icons: device.icons,
        texts: device.texts,
        output: output,
        props: input.properties,
        index: index,
        rendering: input.rendering
    };

    if (is) ret.is = is;

    return ret;
}

function components_create(device, layer) {
    var out = [];

    if (layer == 'l2' && _typeof(device.metadata) == 'object') {
        if ('l2_action' in device.metadata) {
            var keys = device.metadata.l2_action;

            var control = device.controls[keys.control];
            var input = control.variableInputs[keys.input];
            var output = control.variableOutputs[keys.input];

            return [component_create(controlComponents[control.control].l2, component_object(control, device, input, output, keys.input, null))];
        }

        if ('l2_only' in device.metadata) layer = 'l3';
    }

    var _iteratorNormalCompletion6 = true;
    var _didIteratorError6 = false;
    var _iteratorError6 = undefined;

    try {
        for (var _iterator6 = device.controls[Symbol.iterator](), _step6; !(_iteratorNormalCompletion6 = (_step6 = _iterator6.next()).done); _iteratorNormalCompletion6 = true) {
            var _control = _step6.value;

            if (!(_control.control in controlComponents) || !(layer in controlComponents[_control.control])) continue;

            for (var k in _control.variableInputs) {
                var _input = _control.variableInputs[k];
                var _output3 = _control.variableOutputs[k];

                out.push(component_create(controlComponents[_control.control][layer], component_object(_control, device, _input, _output3, k, null)));
            }
        }
    } catch (err) {
        _didIteratorError6 = true;
        _iteratorError6 = err;
    } finally {
        try {
            if (!_iteratorNormalCompletion6 && _iterator6.return) {
                _iterator6.return();
            }
        } finally {
            if (_didIteratorError6) {
                throw _iteratorError6;
            }
        }
    }

    return out;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
// Auflisten der Geräte eines Raums
////////////////////////////////////////////////////////////////////////////////////////////////////////
function house_level2(element, options) {
    var elements = [];
    var devices = interfaceData.rooms[options.room].devices.map(function (dev) {
        return interfaceData.devices[dev];
    });

    var _iteratorNormalCompletion7 = true;
    var _didIteratorError7 = false;
    var _iteratorError7 = undefined;

    try {
        for (var _iterator7 = devices[Symbol.iterator](), _step7; !(_iteratorNormalCompletion7 = (_step7 = _iterator7.next()).done); _iteratorNormalCompletion7 = true) {
            var dev = _step7.value;

            elements = elements.concat(components_create(dev, 'l2'));
        }
    } catch (err) {
        _didIteratorError7 = true;
        _iteratorError7 = err;
    } finally {
        try {
            if (!_iteratorNormalCompletion7 && _iterator7.return) {
                _iterator7.return();
            }
        } finally {
            if (_didIteratorError7) {
                throw _iteratorError7;
            }
        }
    }

    content(this, {
        content: elements,
        name: options.name,
        vue: true
    });
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////////
function house_level3(element, options) {
    var device = interfaceData.devices[options.device];

    content(this, {
        content: components_create(device, 'l3'),
        name: options.name,
        vue: true
    });
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////////
Vue.use({
    install: function install(Vue, opts) {
        Vue.prototype.$homegear = homegear;
    }
});

Vue.mixin({
    data: function data() {
        return {
            interfaceIcons: icons,
            interfaceData: interfaceData
        };
    },
    methods: {
        level3: function level3(device, name) {
            house_level3(this, {
                device: device,
                name: name
            });
        }
    }
});

Vue.component('shif-ctrl-summary', {
    props: ['icon', 'title', 'status', 'actions', 'devs', 'role_id'],

    data: function data() {
        return {
            debug: false,
            submenu_show: false
        };
    },

    computed: {
        dev_objs: function dev_objs() {
            var _this = this;

            return this.devs.map(function (x) {
                return _this.find_component(_this.interfaceData.devices[x], 'l2');
            });
        }
    },

    methods: { // {{{
        find_component: function find_component(device, layer) {
            if (layer == 'l2' && _typeof(device.metadata) == 'object') {
                if ('l2_action' in device.metadata) {
                    var keys = device.metadata.l2_action;

                    var control = device.controls[keys.control];
                    var input = control.variableInputs[keys.input];
                    var output = control.variableOutputs[keys.input];
                    var is = 'shif-' + control.control + '-l2';

                    return [component_object(control, device, input, output, keys.input, is)];
                }

                if ('l2_only' in device.metadata) layer = 'l3';
            }

            var out = [];
            var _iteratorNormalCompletion8 = true;
            var _didIteratorError8 = false;
            var _iteratorError8 = undefined;

            try {
                for (var _iterator8 = device.controls[Symbol.iterator](), _step8; !(_iteratorNormalCompletion8 = (_step8 = _iterator8.next()).done); _iteratorNormalCompletion8 = true) {
                    var _control2 = _step8.value;

                    for (var k in _control2.variableInputs) {
                        var _input2 = _control2.variableInputs[k];
                        var _output4 = _control2.variableOutputs[k];
                        var _is = 'shif-' + _control2.control + '-' + layer;

                        out.push(component_object(_control2, device, _input2, _output4, k, _is));
                    }
                }
            } catch (err) {
                _didIteratorError8 = true;
                _iteratorError8 = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion8 && _iterator8.return) {
                        _iterator8.return();
                    }
                } finally {
                    if (_didIteratorError8) {
                        throw _iteratorError8;
                    }
                }
            }

            return out;
        },

        toggle_all: function toggle_all(action) {
            var varInRole = 'roleId' in action ? this.interfaceData.roles[action.roleId].varInRole : this.interfaceData.roles[this.role_id].varInRole;

            var ops = [];
            for (var peer in varInRole) {
                for (var channel in varInRole[peer]) {
                    var _iteratorNormalCompletion9 = true;
                    var _didIteratorError9 = false;
                    var _iteratorError9 = undefined;

                    try {
                        for (var _iterator9 = varInRole[peer][channel][Symbol.iterator](), _step9; !(_iteratorNormalCompletion9 = (_step9 = _iterator9.next()).done); _iteratorNormalCompletion9 = true) {
                            var name = _step9.value;

                            ops.push({
                                input: { peer: peer, channel: channel, name: name },
                                value: action.value
                            });
                        }
                    } catch (err) {
                        _didIteratorError9 = true;
                        _iteratorError9 = err;
                    } finally {
                        try {
                            if (!_iteratorNormalCompletion9 && _iterator9.return) {
                                _iterator9.return();
                            }
                        } finally {
                            if (_didIteratorError9) {
                                throw _iteratorError9;
                            }
                        }
                    }
                }
            }this.$homegear.value_set_multi(ops);
        }
    }, // }}}

    template: '\n        <div>\n            <shif-generic-l2 v-bind:icon="icon"\n                             v-bind:icon_rotate="submenu_show"\n                             v-bind:title="title"\n                             v-bind:status="status"\n                             v-bind:actions="true"\n                             v-bind:accordion="true"\n                             v-on:click="submenu_show = !submenu_show"\n                             class="accordion">\n            </shif-generic-l2>\n\n            <transition name="slide-fade">\n                <div v-if="submenu_show"\n                     class="categoryContainer"\n                     style="margin-top: 15px;">\n                    <div class="control_button_wrapper">\n                        <template v-for="action in actions">\n                            <shif-button v-bind:width="(100 / actions.length) + \'%\'"\n                                         v-on:click="toggle_all(action)">\n                                {{ action.buttonText }}\n                            </shif-button>\n                        </template>\n                    </div>\n\n                    <template v-for="dev in dev_objs">\n                        <p v-if="debug">{{ dev }}</p>\n                        <component v-bind="dev" v-bind:include_place="true">\n                        </component>\n                        <hr v-if="debug" />\n                    </template>\n                </div>\n            </transition>\n        </div>\n    '
});

var ShifAllDevices = {
    data: function data() {
        var states = {};

        /**
         * Initialize the states so that the status component can show an empty
         * status line without error.
         **/
        var _iteratorNormalCompletion10 = true;
        var _didIteratorError10 = false;
        var _iteratorError10 = undefined;

        try {
            for (var _iterator10 = Object.keys(interfaceData.roles).map(Number)[Symbol.iterator](), _step10; !(_iteratorNormalCompletion10 = (_step10 = _iterator10.next()).done); _iteratorNormalCompletion10 = true) {
                var key = _step10.value;

                states[key] = [];
            }
        } catch (err) {
            _didIteratorError10 = true;
            _iteratorError10 = err;
        } finally {
            try {
                if (!_iteratorNormalCompletion10 && _iterator10.return) {
                    _iterator10.return();
                }
            } finally {
                if (_didIteratorError10) {
                    throw _iteratorError10;
                }
            }
        }

        return {
            status_initialized: false,
            states: states
        };
    },

    computed: {
        map_roles_devs: function map_roles_devs() {
            var ret = {};

            for (var dev_idx in interfaceData.devices) {
                var dev = interfaceData.devices[dev_idx];
                if (!('role' in dev.metadata)) continue;

                var role = dev.metadata.role;
                if (!(role in ret)) ret[role] = [];

                if (ret[role].indexOf(dev_idx) === -1) ret[role].push(dev_idx);
            }

            return ret;
        }
    },

    methods: {
        status_gather_invokes: function status_gather_invokes(role, role_id) {
            var ret = [{
                type: get_or_default(role, 'aggregationType', 2),
                ids: [role_id]
            }];

            if (!('rolesInclude' in role)) return ret;

            var _iteratorNormalCompletion11 = true;
            var _didIteratorError11 = false;
            var _iteratorError11 = undefined;

            try {
                for (var _iterator11 = role.rolesInclude[Symbol.iterator](), _step11; !(_iteratorNormalCompletion11 = (_step11 = _iterator11.next()).done); _iteratorNormalCompletion11 = true) {
                    var role_inc = _step11.value;

                    ret.push({
                        type: get_or_default(role_inc, 'aggregationType', 2),
                        ids: role_inc.roles
                    });
                }
            } catch (err) {
                _didIteratorError11 = true;
                _iteratorError11 = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion11 && _iterator11.return) {
                        _iterator11.return();
                    }
                } finally {
                    if (_didIteratorError11) {
                        throw _iteratorError11;
                    }
                }
            }

            return ret;
        },

        status_text: function status_text(role, texts_idx) {
            if (!('texts' in role)) return '?';

            if (typeof texts_idx === 'number' && role.texts.length > texts_idx || typeof texts_idx === 'string' && texts_idx in role.texts) return role.texts[texts_idx];

            if (role.texts.length == 1) return role.texts[0];

            return '?';
        },

        status: function status(role_id) {
            var _this2 = this;

            var role = interfaceData.roles[role_id];
            var invokes_descs = this.status_gather_invokes(role, role_id);

            var _loop = function _loop(invoke_desc) {
                _this2.$homegear.invoke({
                    jsonrpc: '2.0',
                    method: 'aggregateRoles',
                    params: [invoke_desc.type, invoke_desc.ids, []]
                }, function (res) {
                    if (res.error) {
                        console.log('[' + invoke_desc.ids.join(', ') + ']: ' + res.error.message);
                        return;
                    }

                    /**
                     * Updating this is a two step process:
                     * 1) We need to fetch the new values from upstream.
                     * 2) We need to zero out the outdated old values.
                     **/
                    var keys = Object.keys(res.result).filter(function (x) {
                        return x !== 'variableCount';
                    });
                    var _iteratorNormalCompletion13 = true;
                    var _didIteratorError13 = false;
                    var _iteratorError13 = undefined;

                    try {
                        for (var _iterator13 = keys[Symbol.iterator](), _step13; !(_iteratorNormalCompletion13 = (_step13 = _iterator13.next()).done); _iteratorNormalCompletion13 = true) {
                            var key = _step13.value;

                            /**
                             * We have to be very careful here, to not break Vue's
                             * reactiveness.
                             * 1) In case we need to insert a value, push is needed.
                             * 2) In case we need to change a value, direct
                             *    assignment of the single object members at
                             *    relative array index is needed.
                             **/
                            for (var i = 0; i < _this2.states[role_id].length; ++i) {
                                if (_this2.states[role_id][i].raw == key) {
                                    set_or_extend(_this2.states[role_id], i, {
                                        key: _this2.status_text(role, key),
                                        value: res.result[key],
                                        raw: key
                                    });
                                    break;
                                }
                            }
                        }
                    } catch (err) {
                        _didIteratorError13 = true;
                        _iteratorError13 = err;
                    } finally {
                        try {
                            if (!_iteratorNormalCompletion13 && _iterator13.return) {
                                _iterator13.return();
                            }
                        } finally {
                            if (_didIteratorError13) {
                                throw _iteratorError13;
                            }
                        }
                    }

                    for (var j = _this2.states[role_id].length - 1; j >= 0; --j) {
                        if (keys.indexOf(_this2.states[role_id][j].raw) === -1) _this2.states[role_id][j].value = 0;
                    }
                });
            };

            var _iteratorNormalCompletion12 = true;
            var _didIteratorError12 = false;
            var _iteratorError12 = undefined;

            try {
                for (var _iterator12 = invokes_descs[Symbol.iterator](), _step12; !(_iteratorNormalCompletion12 = (_step12 = _iterator12.next()).done); _iteratorNormalCompletion12 = true) {
                    var invoke_desc = _step12.value;

                    _loop(invoke_desc);
                }
            } catch (err) {
                _didIteratorError12 = true;
                _iteratorError12 = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion12 && _iterator12.return) {
                        _iterator12.return();
                    }
                } finally {
                    if (_didIteratorError12) {
                        throw _iteratorError12;
                    }
                }
            }
        }
    },

    mounted: function mounted() {
        var _this3 = this;

        this.$homegear.ready(function () {
            var _iteratorNormalCompletion14 = true;
            var _didIteratorError14 = false;
            var _iteratorError14 = undefined;

            try {
                for (var _iterator14 = Object.keys(interfaceData.roles).map(Number)[Symbol.iterator](), _step14; !(_iteratorNormalCompletion14 = (_step14 = _iterator14.next()).done); _iteratorNormalCompletion14 = true) {
                    var key = _step14.value;

                    var role = interfaceData.roles[key];

                    if (!('texts' in role)) continue;

                    /**
                     * Always reinitialize to an empty array here.
                     * In case of a homegear reconnect, we would duplicate the
                     * status text otherwise.
                     **/
                    _this3.states[key] = [];
                    /**
                     * This must be a for-in loop! Do not change it into a
                     * traditional for loop or a map.
                     * We need iterate over both, integer keys, as well as object
                     * keys (iteration order does not matter for the integer keys).
                     **/
                    for (var text_idx in role.texts) {
                        _this3.states[key].push({
                            key: _this3.status_text(role, text_idx),
                            raw: text_idx + '',
                            value: 0
                        });
                    }_this3.status(key);
                }
            } catch (err) {
                _didIteratorError14 = true;
                _iteratorError14 = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion14 && _iterator14.return) {
                        _iterator14.return();
                    }
                } finally {
                    if (_didIteratorError14) {
                        throw _iteratorError14;
                    }
                }
            }
        });

        this.$root.$on('role-update', function (role_id) {
            return _this3.status(Number(role_id));
        });
    },

    template: '\n        <div>\n            <template v-for="(devs, role) in map_roles_devs">\n                <shif-ctrl-summary\n                    v-on:role_update="status"\n                    v-bind:actions="interfaceData.roles[role].invokeOutputs"\n                    v-bind:icon="interfaceData.roles[role].icon"\n                    v-bind:title="interfaceData.roles[role].name"\n                    v-bind:devs="devs"\n                    v-bind:role_id="role"\n                    v-bind:status="states[role]">\n                </shif-ctrl-summary>\n            </template>\n        </div>\n    '
};

var app = new Vue({
    el: '#inhalt',

    components: {
        ShifAllDevices: ShifAllDevices
    }
});

////////////////////////////////////////////////////////////////////////////////////////////////////////
// Icon anzeigen
////////////////////////////////////////////////////////////////////////////////////////////////////////
function showIcon(icon) {
    if (icon in icons) return '<div class="svg_icon ' + icon + '">' + icons[icon] + '</div>';else return '<div class="svg_icon icon_default">' + icons.question1 + '</div>';
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////////
var lighting_switch_l2 = clone(shif_device);
lighting_switch_l2.methods.change = function (event) {
    homegear.value_set_clickcounter(this, this.output, !this.props.value);
};
lighting_switch_l2.template = '\n    <shif-generic-l2 v-bind:icon="cond.icon.name"\n                     v-bind:title="dev.label"\n                     v-bind:active="{icon: cond.icon.color, text: cond.text.color}"\n                     v-bind:status="status"\n                     v-bind:place="place"\n                     v-bind:actions="true"\n                     v-on:click_icon="change($event, true)"\n                     v-on:click="level3(device, breadcrumb)">\n    </shif-generic-l2>\n';

var lighting_switch_l3 = clone(shif_device);
lighting_switch_l3.methods.change = function (event) {
    homegear.value_set_clickcounter(this, this.output, !this.props.value);
};
lighting_switch_l3.template = '\n    <shif-generic-l2 v-bind:icon="cond.icon.name"\n                     v-bind:title="title"\n                     v-bind:active="{icon: cond.icon.color, text: cond.text.color}"\n                     v-bind:place="place"\n                     v-bind:status="status_minimal"\n                     v-on:click="change">\n    </shif-generic-l2>\n';

shif_comps_create('lightingSwitch', lighting_switch_l2, lighting_switch_l3);

var lighting_brightness = clone(shif_device);
lighting_brightness.methods.change = function (event) {
    homegear.value_set_clickcounter(this, this.output, this.props.value);
};
lighting_brightness.template = '\n    <shif-slider v-bind:min="props.minimumScaled"\n                 v-bind:max="props.maximumScaled"\n                 v-bind:unit="props.unit"\n                 v-bind:value="props.value"\n                 v-bind:title="title"\n                 v-on:change="change"\n                 v-model:value="props.value">\n    </shif-slider>\n';

shif_comps_create('lightingBrightness', lighting_switch_l2, lighting_brightness);

var lighting_button_l2 = clone(shif_device);
lighting_button_l2.template = '\n    <shif-generic-l2 v-bind:icon="cond.icon.name"\n                     v-bind:title="dev.label"\n                     v-bind:active="{icon: cond.icon.color, text: cond.text.color}"\n                     v-bind:status="status"\n                     v-bind:place="place"\n                     v-on:click="level3(device, breadcrumb)">\n    </shif-generic-l2>\n';

var lighting_button_l3 = clone(shif_device);
lighting_button_l3.methods.change = function (event, down) {
    homegear.value_set_clickcounter(this, this.output, down);
};
lighting_button_l3.template = '\n    <shif-generic-l2 v-bind:icon="cond.icon.name"\n                     v-bind:title="title"\n                     v-bind:active="{icon: cond.icon.color, text: cond.text.color}"\n                     v-bind:status="status_minimal"\n                     v-bind:place="place"\n                     v-on:mousedown="change($event, true)"\n                     v-on:mouseup="change($event, false)">\n    </shif-generic-l2>\n';

shif_comps_create('lightingButton', lighting_button_l2, lighting_button_l3);

////////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////////
$(document).ready(function () {
    var mainmenuItemWidth = 100 / Object.keys(interfaceData.mainmenu).length;
    var mainmenuItem = '';

    $.each(interfaceData.mainmenu, function (key, value) {
        var active = value.name === firstBreadcrumbId ? 'active' : '';

        mainmenuItem += '\n            <li style="width: ' + mainmenuItemWidth + '%;" onclick="' + value.onclick + ';">\n                <div id="mainmenu_' + value.name + '" class="mainmenu_button ' + active + '">' + showIcon(value.icon) + '</div>\n            </li>\n        ';
    });

    $('#inhalt').after('\n        <div id="mainmenu">\n            <ul class="menu">\n                ' + mainmenuItem + '\n            </ul>\n        </div>\n    ');

    if (firstBreadcrumbId == 'house') $('#houseJS').html(house_level1_content);else if (firstBreadcrumbId == 'widgets') {
        main(this, {
            name: 'Widgets',
            content: 'widgets',
            menu: 'widgets'
        });
    }
});

////////////////////////////////////////////////////////////////////////////////////////////////////////
// zeigt den Rauminhalt
////////////////////////////////////////////////////////////////////////////////////////////////////////
function main(element, options) {

    for (var i = 1; i < breadcrumbs_id_array.length; i++) {
        $('#' + breadcrumbs_id_array[i]).remove();
    }breadcrumbs_id_array = [options.content];

    $('.content_single').removeClass('content_single');
    $('.content_small').removeClass('content_small');
    $('.content_big').removeClass('content_big');
    $('.content_back').remove();

    $('.mainmenu_button').removeClass('active');
    $('#mainmenu_' + options.content).addClass('active');

    $('#back').addClass('inactive');

    if ('menu' in options) {
        $('#' + options.content).html(menu({
            mainmenu: options.menu,
            level: '1'
        }));
    }

    $('#' + options.content).addClass('content_single');
    $('.content').scrollTop(0);

    breadcrumbs_array = ['\n        <div class="breadcrumbsJump" onclick=\'main(this, {"name":"' + options.name + '","content":"' + options.content + '"});\'>\n            ' + options.name + '\n        </div>\n    '];

    var text = '';
    for (var _i5 = 0; _i5 < breadcrumbs_array.length; _i5++) {
        text += breadcrumbs_array[_i5];

        if (_i5 + 1 != breadcrumbs_array.length) text += '<div class="breadcrumbs_separator">|</div>';
    }

    document.getElementById('breadcrumbsSub').innerHTML = text;

    $('#breadcrumbsSub').scrollLeft(9999999999);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////////
function menu(options) {
    var menu = '';

    $.each(interfaceData.menu, function (key, value) {
        if (options.mainmenu !== value.mainmenu || options.level !== value.level) return;

        if ('category' in options && options.category !== value.category) return;

        menu += '\n            <div class="button" onclick="' + value.onclick + '">\n                <div class="button_icon">\n                    ' + showIcon(value.icon) + '\n                </div>\n                <div class="button_text">\n                    <div class="button_title">' + value.name + '</div>\n                    <br/>\n                    <div class="button_status">' + value.description + '</div>\n                </div>\n                <div class="button_action">\n                    ' + showIcon('pfeil3') + '\n                </div>\n            </div>\n        ';
    });

    if ('content' in options && options.content === 'true') {
        content('this', {
            content: menu,
            name: options.name
        });
    } else return menu;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////////
var socket_switch_l2 = clone(shif_device);
socket_switch_l2.methods.change = function (event) {
    homegear.value_set_clickcounter(this, this.output, !this.props.value);
};
socket_switch_l2.template = '\n    <shif-generic-l2 v-bind:icon="cond.icon.name"\n                     v-bind:title="dev.label"\n                     v-bind:active="{icon: cond.icon.color, text: cond.text.color}"\n                     v-bind:status="status"\n                     v-bind:place="place"\n                     v-bind:actions="true"\n                     v-on:click_icon="change"\n                     v-on:click="level3(device, breadcrumb)">\n    </shif-generic-l2>\n';

var socket_switch_l3 = clone(shif_device);
socket_switch_l3.methods.change = function (event) {
    homegear.value_set_clickcounter(this, this.output, !this.props.value);
};
socket_switch_l3.template = '\n    <shif-generic-l2 v-bind:icon="cond.icon.name"\n                     v-bind:title="title"\n                     v-bind:active="{icon: cond.icon.color, text: cond.text.color}"\n                     v-bind:place="place"\n                     v-bind:status="status_minimal"\n                     v-on:click="change">\n    </shif-generic-l2>\n';

shif_comps_create('socketSwitch', socket_switch_l2, socket_switch_l3);

var socket_button_l2 = clone(shif_device);
socket_button_l2.template = '\n    <shif-generic-l2 v-bind:icon="cond.icon.name"\n                     v-bind:title="dev.label"\n                     v-bind:active="{icon: cond.icon.color, text: cond.text.color}"\n                     v-bind:status="status"\n                     v-bind:place="place"\n                     v-on:click="level3(device, breadcrumb)">\n    </shif-generic-l2>\n';

var socket_button_l3 = clone(shif_device);
socket_button_l3.methods.change = function (event, down) {
    homegear.value_set_clickcounter(this, this.output, down);
};
socket_button_l3.template = '\n    <shif-generic-l2 v-bind:icon="cond.icon.name"\n                     v-bind:title="title"\n                     v-bind:active="{icon: cond.icon.color, text: cond.text.color}"\n                     v-bind:status="status_minimal"\n                     v-bind:place="place"\n                     v-on:mousedown="change($event, true)"\n                     v-on:mouseup="change($event, false)">\n    </shif-generic-l2>\n';

shif_comps_create('socketButton', socket_button_l2, socket_button_l3);

////////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////////
var humidity = clone(shif_device);
humidity.template = '\n    <shif-generic-l2 v-bind:icon="icons.humidity.name"\n                     v-bind:title="dev.label"\n                     v-bind:active="{icon: icons.humidity.color, text: texts.title.color}"\n                     v-bind:status="status"\n                     v-bind:place="place">\n    </shif-generic-l2>\n';

var temperature = clone(shif_device);
temperature.template = '\n    <shif-generic-l2 v-bind:icon="icons.temperature.name"\n                     v-bind:title="dev.label"\n                     v-bind:active="{icon: icons.temperature.color, text: texts.title.color}"\n                     v-bind:status="status"\n                     v-bind:place="place">\n    </shif-generic-l2>\n';

shif_comps_create('humidity', humidity, humidity);
shif_comps_create('temperature', temperature, temperature);

////////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////////
var heating_slider_l2 = clone(shif_device);
heating_slider_l2.methods.change = function (event) {
    homegear.value_set_clickcounter(this, this.output, !this.props.value);
};
heating_slider_l2.template = '\n    <shif-generic-l2 v-bind:icon="cond.icon.name"\n                     v-bind:title="dev.label"\n                     v-bind:active="{icon: cond.icon.color, text: cond.text.color}"\n                     v-bind:status="status"\n                     v-bind:place="place"\n                     v-bind:actions="true"\n                     v-on:click_icon="change"\n                     v-on:click="level3(device, breadcrumb)">\n    </shif-generic-l2>\n';
var heating_slider_l3 = clone(shif_device);
heating_slider_l3.methods.change = function (event) {
    homegear.value_set_clickcounter(this, this.output, this.props.value);
};
heating_slider_l3.template = '\n    <shif-slider v-bind:min="props.minimumScaled"\n                 v-bind:max="props.maximumScaled"\n                 v-bind:unit="props.unit"\n                 v-bind:value="props.value"\n                 v-bind:title="title"\n                 v-on:change="change"\n                 v-model:value="props.value">\n    </shif-slider>\n';

shif_comps_create('heatingSlider', heating_slider_l2, heating_slider_l3);

var heating_is_state_l2 = clone(shif_device);
heating_is_state_l2.template = '\n    <shif-generic-l2 v-bind:icon="control.icons.temperature.name"\n                     v-bind:title="dev.label"\n                     v-bind:active="{icon: control.icons.temperature.color, text: texts.title.color}"\n                     v-bind:status="status"\n                     v-bind:actions="true"\n                     v-bind:place="place"\n                     v-on:click="level3(device, breadcrumb)">\n    </shif-generic-l2>\n';
var heating_is_state_l3 = clone(shif_device);
heating_is_state_l3.template = '\n    <shif-generic-l2 v-bind:icon="control.icons.temperature.name"\n                     v-bind:title="title"\n                     v-bind:active="{icon: control.icons.temperature.color, text: texts.title.color}"\n                     v-bind:status="status"\n                     v-bind:place="place">\n    </shif-generic-l2>\n';

shif_comps_create('heatingIsState', heating_is_state_l2, heating_is_state_l3);

var heating_mode_l3 = clone(shif_device);
heating_mode_l3.computed.values = function () {
    var _this4 = this;

    return this.rendering.map(function (x) {
        return {
            name: x.definitions.texts.state.content,
            value: x.condition.value,
            selected: x.condition.value == _this4.props.value
        };
    });
};
heating_mode_l3.methods.change = function (x) {
    homegear.value_set_clickcounter(this, this.output, x);
};
heating_mode_l3.template = '\n    <shif-radio v-bind:title="title"\n                v-bind:values="values"\n                v-on:input="x => change(parseInt(x))">\n    </shif-radio>\n';

shif_comps_create('heatingMode', heating_is_state_l2, heating_mode_l3);

var heating_window_l2 = clone(shif_device);
heating_window_l2.methods.change = function (event) {
    homegear.value_set_clickcounter(this, this.output, !this.props.value);
};
heating_window_l2.template = '\n    <shif-generic-l2 v-bind:icon="cond.icon.name"\n                     v-bind:title="dev.label"\n                     v-bind:active="{icon: cond.icon.color, text: cond.text.color}"\n                     v-bind:status="status"\n                     v-bind:place="place"\n                     v-bind:actions="true"\n                     v-on:click_icon="change"\n                     v-on:click="level3(device, breadcrumb)">\n    </shif-generic-l2>\n';

var heating_window_l3 = clone(shif_device);
heating_window_l3.methods.change = function (event) {
    homegear.value_set_clickcounter(this, this.output, !this.props.value);
};
heating_window_l3.template = '\n    <shif-generic-l2 v-bind:icon="cond.icon.name"\n                     v-bind:title="title"\n                     v-bind:active="{icon: cond.icon.color, text: cond.text.color}"\n                     v-bind:place="place"\n                     v-bind:status="status_minimal"\n                     v-on:click="change">\n    </shif-generic-l2>\n';

shif_comps_create('heatingWindow', heating_window_l2, heating_window_l3);
////////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////////
var ventilation_mode_l2 = clone(shif_device);
ventilation_mode_l2.template = '\n    <shif-generic-l2 v-bind:icon="icons.l2.name"\n                     v-bind:title="dev.label"\n                     v-bind:active="{icon: icons.l2.color, text: texts.title.color}"\n                     v-bind:place="place"\n                     v-bind:actions="true"\n                     v-bind:status="status"\n                     v-on:click="level3(device, breadcrumb)">\n    </shif-generic-l2>\n';

var ventilation_mode_l3 = clone(shif_device);
heating_mode_l3.methods.change = function (x) {
    homegear.value_set_clickcounter(this, this.output, x);
};
ventilation_mode_l3.computed.values = function () {
    var _this5 = this;

    return this.rendering.map(function (x) {
        return {
            name: x.definitions.texts.state.content,
            value: x.condition.value,
            selected: x.condition.value == _this5.props.value
        };
    });
};
ventilation_mode_l3.template = '\n    <shif-radio v-bind:title="title"\n                v-bind:values="values"\n                v-on:input="x => change(parseInt(x))">\n    </shif-radio>\n';

shif_comps_create('ventilationMode', ventilation_mode_l2, ventilation_mode_l3);
